﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using DlhSoft.Windows.Controls;

namespace ScheduleChartDataGridMouseEventHandlingSample
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            GanttChartItem task1 = ScheduleChartDataGrid.Items[0].GanttChartItems[0];
            task1.Start = DateTime.Today.Add(TimeSpan.Parse("08:00:00"));
            task1.Finish = DateTime.Today.Add(TimeSpan.Parse("16:00:00"));
            task1.CompletedFinish = DateTime.Today.Add(TimeSpan.Parse("12:00:00"));

            GanttChartItem task21 = ScheduleChartDataGrid.Items[0].GanttChartItems[1];
            task21.Start = DateTime.Today.AddDays(1).Add(TimeSpan.Parse("12:00:00"));
            task21.Finish = DateTime.Today.AddDays(2).Add(TimeSpan.Parse("16:00:00"));
            task21.AssignmentsContent = "50%";

            GanttChartItem task22 = ScheduleChartDataGrid.Items[1].GanttChartItems[0];
            task22.Start = DateTime.Today.AddDays(1).Add(TimeSpan.Parse("12:00:00"));
            task22.Finish = DateTime.Today.AddDays(2).Add(TimeSpan.Parse("16:00:00"));
        }

        private void ScheduleChartDataGrid_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            Point controlPosition = e.GetPosition(ScheduleChartDataGrid);
            Point contentPosition = e.GetPosition(ScheduleChartDataGrid.ChartContentElement);

            DateTime dateTime = ScheduleChartDataGrid.GetDateTime(contentPosition.X);
            ScheduleChartItem itemRow = ScheduleChartDataGrid.GetItemAt(contentPosition.Y);

            GanttChartItem item = null;
            FrameworkElement frameworkElement = e.OriginalSource as FrameworkElement;
            if (frameworkElement != null)
                item = frameworkElement.DataContext as GanttChartItem;

            if (controlPosition.X < ScheduleChartDataGrid.ActualWidth - ScheduleChartDataGrid.GanttChartView.ActualWidth)
                return;
            if (controlPosition.Y < ScheduleChartDataGrid.HeaderHeight)
                MessageBox.Show(string.Format("You have clicked the chart scale header at date and time {0:g}.", dateTime), "Mouse Click Details", MessageBoxButton.OK);
            else if (item != null)
                MessageBox.Show(string.Format("You have clicked the task item '{0}' assigned to resource item '{1}' at date and time {2:g}.", item, itemRow, dateTime > item.Finish ? item.Finish : dateTime), "Mouse Click Details", MessageBoxButton.OK);
            else if (itemRow != null)
                MessageBox.Show(string.Format("You have clicked at date and time {0:g} within the row of item '{1}'.", dateTime, itemRow), "Mouse Click Details", MessageBoxButton.OK);
            else
                MessageBox.Show(string.Format("You have clicked at date and time {0:g} within an empty area of the chart.", dateTime), "Mouse Click Details", MessageBoxButton.OK);
        }
    }
}
